
Redmine - Defect #29730

Previous/Next link on repository page disappear when switching to "View differences" tab

2018-10-04 17:45 - Go MAEDA

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: SCM Estimated time: 0.00 hour

Target version:    

Resolution:  Affected version:  

Description

See the screenshots below.

 

 

Related issues:

Related to Redmine - Feature #26576: Use tabs to switch between file changes ... Closed

Has duplicate Redmine - Feature #8254: Add previous/next functionality in diffs Closed 2011-04-30

Associated revisions

Revision 17605 - 2018-10-28 12:59 - Go MAEDA

Previous/Next link on repository page disappears when switching to "View differences" tab (#26576, #29730).

Patch by Mizuki ISHIKAWA.

Revision 17606 - 2018-10-29 01:18 - Go MAEDA

Reverted r17605 that breaks some tests (#26576, #29730).

Revision 17620 - 2018-11-05 03:40 - Go MAEDA

Previous/Next link on repository page disappears when switching to "View differences" tab (#26576, #29730).

Patch by Mizuki ISHIKAWA.
History

#1 - 2018-10-04 17:46 - Go MAEDA

- Related to Feature #26576: Use tabs to switch between file changes and diff of a commit added

#2 - 2018-10-15 06:41 - Mizuki ISHIKAWA

- File fix-29730.patch added

By applying this patch I think that the Previous/Next link will be displayed.

#3 - 2018-10-28 13:00 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed. Thank you for fixing this issue.

#4 - 2018-10-28 13:26 - Marius BĂLTEANU

- Target version set to 4.0.0

#5 - 2018-10-29 01:11 - Go MAEDA

- Status changed from Closed to Reopened

- Target version changed from 4.0.0 to Candidate for next major release

- Resolution deleted (Fixed)

The patch breaks some tests. Reverted the change.

ShowHide

# Running:

..............................................................................................................

............................................................F

Failure:

RepositoriesGitTest#test_diff_two_revs [/var/lib/jenkins/workspace/trunk/DATABASE_ADAPTER/sqlite3/RUBY_VER/rub

y-2.5/test/integration/repositories_git_test.rb:47]:

Expected response to be a <2XX: success>, but was a <500: Internal Server Error>

bin/rails test test/integration/repositories_git_test.rb:45

..............................................................................................................

..............................................................................................................

..............................................................................................................

.....................................................................SS.......................................

..............................................................................................................

..............................................................................................................

..............................................................................................................

..............................................................................................................

..............................................................................................................

..............................................................................................................

..............................................................................................................

..............................................................................................................

..............................................................................................................

..............................................................................................................

..............................................................................................................

..............................................................E

Error:

RepositoriesGitControllerTest#test_save_diff_type:

ActionView::Template::Error: undefined method `previous' for nil:NilClass

    app/views/repositories/diff.html.erb:3:in `_app_views_repositories_diff_html_erb__749227865__1013454858'

    lib/redmine/sudo_mode.rb:63:in `sudo_mode'

    test/functional/repositories_git_controller_test.rb:472:in `test_save_diff_type'

bin/rails test test/functional/repositories_git_controller_test.rb:464
...........E

Error:

RepositoriesGitControllerTest#test_diff_path_in_subrepo:

ActionView::Template::Error: undefined method `previous' for nil:NilClass

    app/views/repositories/diff.html.erb:3:in `_app_views_repositories_diff_html_erb__749227865__1013454858'

    lib/redmine/sudo_mode.rb:63:in `sudo_mode'

    test/functional/repositories_git_controller_test.rb:414:in `test_diff_path_in_subrepo'

bin/rails test test/functional/repositories_git_controller_test.rb:404

...E

Error:

RepositoriesGitControllerTest#test_diff_should_show_filenames:

ActionView::Template::Error: undefined method `previous' for nil:NilClass

    app/views/repositories/diff.html.erb:3:in `_app_views_repositories_diff_html_erb__749227865__1013454858'

    lib/redmine/sudo_mode.rb:63:in `sudo_mode'

    test/functional/repositories_git_controller_test.rb:451:in `test_diff_should_show_filenames'

bin/rails test test/functional/repositories_git_controller_test.rb:450

......E

Error:

RepositoriesGitControllerTest#test_diff_latin_1:

ActionView::Template::Error: undefined method `previous' for nil:NilClass

    app/views/repositories/diff.html.erb:3:in `_app_views_repositories_diff_html_erb__749227865__1013454858'

    lib/redmine/sudo_mode.rb:63:in `sudo_mode'

    test/functional/repositories_git_controller_test.rb:433:in `block (3 levels) in test_diff_latin_1'

    test/functional/repositories_git_controller_test.rb:432:in `each'

    test/functional/repositories_git_controller_test.rb:432:in `block (2 levels) in test_diff_latin_1'

    test/functional/repositories_git_controller_test.rb:431:in `each'

    test/functional/repositories_git_controller_test.rb:431:in `block in test_diff_latin_1'

    test/test_helper.rb:93:in `with_settings'

    test/functional/repositories_git_controller_test.rb:430:in `test_diff_latin_1'

bin/rails test test/functional/repositories_git_controller_test.rb:426

..............................................................................................................

..............................................................................................................

..............................................................E

Error:

RepositoriesMercurialControllerTest#test_diff_should_show_deleted_filenames:

ActionView::Template::Error: undefined method `previous' for nil:NilClass

    app/views/repositories/diff.html.erb:3:in `_app_views_repositories_diff_html_erb__749227865__1013454858'

    lib/redmine/sudo_mode.rb:63:in `sudo_mode'

    test/functional/repositories_mercurial_controller_test.rb:416:in `test_diff_should_show_deleted_filenames'

bin/rails test test/functional/repositories_mercurial_controller_test.rb:415

..E

Error:

RepositoriesMercurialControllerTest#test_diff_latin_1_path:

ActionView::Template::Error: undefined method `previous' for nil:NilClass

    app/views/repositories/diff.html.erb:3:in `_app_views_repositories_diff_html_erb__749227865__1013454858'

    lib/redmine/sudo_mode.rb:63:in `sudo_mode'

    test/functional/repositories_mercurial_controller_test.rb:388:in `block (3 levels) in test_diff_latin_1_pa

th'

    test/functional/repositories_mercurial_controller_test.rb:387:in `each'

    test/functional/repositories_mercurial_controller_test.rb:387:in `block (2 levels) in test_diff_latin_1_pa

th'

    test/functional/repositories_mercurial_controller_test.rb:386:in `each'

    test/functional/repositories_mercurial_controller_test.rb:386:in `block in test_diff_latin_1_path'

    test/test_helper.rb:93:in `with_settings'

    test/functional/repositories_mercurial_controller_test.rb:385:in `test_diff_latin_1_path'

bin/rails test test/functional/repositories_mercurial_controller_test.rb:384

E

Error:

RepositoriesMercurialControllerTest#test_diff_should_show_modified_filenames:
ActionView::Template::Error: undefined method `previous' for nil:NilClass

    app/views/repositories/diff.html.erb:3:in `_app_views_repositories_diff_html_erb__749227865__1013454858'

    lib/redmine/sudo_mode.rb:63:in `sudo_mode'

    test/functional/repositories_mercurial_controller_test.rb:405:in `test_diff_should_show_modified_filenames

'

bin/rails test test/functional/repositories_mercurial_controller_test.rb:404

..............................................................................................................

..............................................................................................................

..............................................................................................................

..............................................................................................................

..............................................................................................................

..............................................................................................................

..............................................................................................................

..............................................................................................................

..............................................................................................................

..............................................................................................................

..........................................................Deprecation warning: Net::LDAP::ConnectionRefused wi

ll be deprecated. Use Errno::ECONNREFUSED instead.

Deprecation warning: Net::LDAP::ConnectionRefused will be deprecated. Use Errno::ECONNREFUSED instead.

..............................................................................................................

..............................................................................................................

..............................................................................................................

..............................................................................................................

..............................................................................................................

........................................................................S.....................................

..............................................................................................................

..............................................................................................................

..............................................................................................................

..............................................................................................................

..............................................................................................................

...................................................................................................E

Error:

RepositoriesBazaarControllerTest#test_diff:

ActionView::Template::Error: undefined method `previous' for nil:NilClass

    app/views/repositories/diff.html.erb:3:in `_app_views_repositories_diff_html_erb__749227865__1013454858'

    lib/redmine/sudo_mode.rb:63:in `sudo_mode'

    test/functional/repositories_bazaar_controller_test.rb:146:in `block in test_diff'

    test/functional/repositories_bazaar_controller_test.rb:145:in `each'

    test/functional/repositories_bazaar_controller_test.rb:145:in `test_diff'

bin/rails test test/functional/repositories_bazaar_controller_test.rb:143

.................

Finished in 428.714970s, 10.9140 runs/s, 49.5901 assertions/s.

4679 runs, 21260 assertions, 1 failures, 8 errors, 3 skips

You have skipped tests. Run with --verbose for details.

#6 - 2018-10-29 02:50 - Mizuki ISHIKAWA

Go MAEDA wrote:

The patch breaks some tests. Reverted the change.

 I'm sorry, I missed the result of the test.

If you add the following code to the patch of #29730#note-2 , the tests should succeed.

diff --git a/app/views/repositories/diff.html.erb b/app/views/repositories/diff.html.erb

index 12875f21ee..3dcc0fdc79 100644

--- a/app/views/repositories/diff.html.erb

+++ b/app/views/repositories/diff.html.erb

@@ -1,3 +1,4 @@

+<% if @changeset && @changeset_to.nil? %>

 <div class="contextual">

   &#171;

   <% unless @changeset.previous.nil? -%>

@@ -25,7 +26,6 @@

     <%= submit_tag 'OK', :name => nil %>
   <% end %>

 </div>

-<% if @changeset && @changeset_to.nil? %>

 <%= render :partial => 'changeset' %>

 <% else %>

 <h2><%= l(:label_revision) %> <%= @diff_format_revisions %> <%= @path %></h2>

diff --git a/tmp/test/empty b/tmp/test/empty

deleted file mode 100644

index e69de29bb2..0000000000

#7 - 2018-11-05 03:44 - Go MAEDA

- Status changed from Reopened to Closed

- Target version deleted (Candidate for next major release)

Committed the patch again. Thanks.

I don't set the target version of this issue because I think this is a fix for #26576, one of a new feature of Redmine 4.0.0 which is not released yet (no

releases are affected by this issue).

#8 - 2019-02-03 12:29 - Go MAEDA

- Has duplicate Feature #8254: Add previous/next functionality in diffs added

Files

changes-tab@2x.png 33.1 KB 2018-10-04 Go MAEDA

diff-tab@2x.png 35.6 KB 2018-10-04 Go MAEDA

fix-29730.patch 1.19 KB 2018-10-15 Mizuki ISHIKAWA
